osgGA::OrbitManipulator Class Reference

`#include <OrbitManipulator>`

Inheritance diagram for osgGA::OrbitManipulator:

## Classes

class | OrbitAnimationData

## Public Member Functions

| OrbitManipulator (int flags=DEFAULT_SETTINGS)
| OrbitManipulator (const OrbitManipulator &om, const osg::CopyOp &copyOp=osg::CopyOp::SHALLOW_COPY)
| META_Object (osgGA, OrbitManipulator)
virtual void | setByMatrix (const osg::Matrixd &matrix)
virtual void | setByInverseMatrix (const osg::Matrixd &matrix)
virtual osg::Matrixd | getMatrix () const
virtual osg::Matrixd | getInverseMatrix () const
virtual void | setTransformation (const osg::Vec3d &eye, const osg::Quat &rotation)
virtual void | setTransformation (const osg::Vec3d &eye, const osg::Vec3d &center, const osg::Vec3d &up)
virtual void | getTransformation (osg::Vec3d &eye, osg::Quat &rotation) const
virtual void | getTransformation (osg::Vec3d &eye, osg::Vec3d &center, osg::Vec3d &up) const
void | setHeading (double azimuth)
double | getHeading () const
void | setElevation (double elevation)
double | getElevation () const
virtual void | setCenter (const osg::Vec3d &center)
const osg::Vec3d & | getCenter () const
virtual void | setRotation (const osg::Quat &rotation)
const osg::Quat & | getRotation () const
virtual void | setDistance (double distance)
double | getDistance () const
virtual void | setTrackballSize (const double &size)
double | getTrackballSize () const
virtual void | setWheelZoomFactor (double wheelZoomFactor)
double | getWheelZoomFactor () const
virtual void | setMinimumDistance (const double &minimumDistance, bool relativeToModelSize=false)
double | getMinimumDistance (bool *relativeToModelSize=NULL) const
virtual osgUtil::SceneView::FusionDistanceMode | getFusionDistanceMode () const
virtual float | getFusionDistanceValue () const
Public Member Functions inherited from osgGA::StandardManipulator
| StandardManipulator (int flags=DEFAULT_SETTINGS)
| StandardManipulator (const StandardManipulator &m, const osg::CopyOp &copyOp=osg::CopyOp::SHALLOW_COPY)
virtual const char * | className () const
virtual void | setNode (osg::Node *)
virtual const osg::Node * | getNode () const
virtual osg::Node * | getNode ()
virtual void | setVerticalAxisFixed (bool value)
bool | getVerticalAxisFixed () const
| Returns whether manipulator preserves camera's "UP" vector.
bool | getAllowThrow () const
| Returns true if the camera can be thrown, false otherwise. It defaults to true.
virtual void | setAllowThrow (bool allowThrow)
virtual void | setAnimationTime (const double t)
double | getAnimationTime () const
bool | isAnimating () const
virtual void | finishAnimation ()
virtual void | home (const osgGA::GUIEventAdapter &ea, osgGA::GUIActionAdapter &us)
virtual void | home (double)
virtual void | init (const osgGA::GUIEventAdapter &ea, osgGA::GUIActionAdapter &us)
virtual bool | handle (const osgGA::GUIEventAdapter &ea, osgGA::GUIActionAdapter &us)
virtual void | getUsage (osg::ApplicationUsage &usage) const
Public Member Functions inherited from osgGA::CameraManipulator
virtual void | setCoordinateFrameCallback (CoordinateFrameCallback *cb)
CoordinateFrameCallback * | getCoordinateFrameCallback ()
const CoordinateFrameCallback * | getCoordinateFrameCallback () const
osg::CoordinateFrame | getCoordinateFrame (const osg::Vec3d &position) const
osg::Vec3d | getSideVector (const osg::CoordinateFrame &cf) const
osg::Vec3d | getFrontVector (const osg::CoordinateFrame &cf) const
osg::Vec3d | getUpVector (const osg::CoordinateFrame &cf) const
virtual void | updateCamera (osg::Camera &camera)
void | setIntersectTraversalMask (unsigned int mask)
unsigned int | getIntersectTraversalMask () const
virtual void | setHomePosition (const osg::Vec3d &eye, const osg::Vec3d &center, const osg::Vec3d &up, bool autoComputeHomePosition=false)
virtual void | getHomePosition (osg::Vec3d &eye, osg::Vec3d &center, osg::Vec3d &up) const
virtual void | setAutoComputeHomePosition (bool flag)
bool | getAutoComputeHomePosition () const
virtual void | computeHomePosition (const osg::Camera *camera=NULL, bool useBoundingBox=false)
virtual bool | handle (osgGA::Event *event, osg::Object *object, osg::NodeVisitor *nv)
Public Member Functions inherited from osgGA::GUIEventHandler
| GUIEventHandler ()
| GUIEventHandler (const GUIEventHandler &eh, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
| META_Object (osgGA, GUIEventHandler)
virtual bool | handle (const GUIEventAdapter &ea, GUIActionAdapter &aa, osg::Object *, osg::NodeVisitor *)
Public Member Functions inherited from osgGA::EventHandler
| EventHandler ()
| EventHandler (const EventHandler &eh, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
| META_Object (osgGA, EventHandler)
virtual NodeCallback * | asNodeCallback ()
virtual const NodeCallback * | asNodeCallback () const
virtual DrawableEventCallback * | asDrawableEventCallback ()
virtual const DrawableEventCallback * | asDrawableEventCallback () const
virtual EventHandler * | asEventHandler ()
virtual const EventHandler * | asEventHandler () const
virtual bool | run (osg::Object *object, osg::Object *data)
virtual void | operator() (osg::Node *node, osg::NodeVisitor *nv)
virtual void | event (osg::NodeVisitor *nv, osg::Drawable *drawable)
Public Member Functions inherited from osg::NodeCallback
| NodeCallback ()
| NodeCallback (const NodeCallback &nc, const CopyOp &copyop)
| META_Object (osg, NodeCallback)
Public Member Functions inherited from osg::Callback
| Callback ()
| Callback (const Callback &cb, const CopyOp &copyop)
| META_Object (osg, Callback)
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual StateAttributeCallback * | asStateAttributeCallback ()
virtual const StateAttributeCallback * | asStateAttributeCallback () const
virtual UniformCallback * | asUniformCallback ()
virtual const UniformCallback * | asUniformCallback () const
virtual DrawableUpdateCallback * | asDrawableUpdateCallback ()
virtual const DrawableUpdateCallback * | asDrawableUpdateCallback () const
virtual DrawableCullCallback * | asDrawableCullCallback ()
virtual const DrawableCullCallback * | asDrawableCullCallback () const
bool | traverse (osg::Object *object, osg::Object *data)
void | setNestedCallback (osg::Callback *cb)
osg::Callback * | getNestedCallback ()
const osg::Callback * | getNestedCallback () const
void | addNestedCallback (osg::Callback *nc)
void | removeNestedCallback (osg::Callback *nc)
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const =0
virtual Object * | clone (const CopyOp &) const =0
virtual bool | isSameKindAs (const Object *) const
virtual const char * | libraryName () const =0
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
virtual void | resizeGLObjectBuffers (unsigned int)
virtual void | releaseGLObjects (osg::State *=0) const
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const
Public Member Functions inherited from osg::DrawableEventCallback
| DrawableEventCallback ()
| DrawableEventCallback (const DrawableEventCallback &org, const CopyOp &copyop)
| META_Object (osg, DrawableEventCallback)

## Protected Member Functions

virtual bool | handleMouseWheel (const osgGA::GUIEventAdapter &ea, osgGA::GUIActionAdapter &us)
virtual bool | performMovementLeftMouseButton (const double eventTimeDelta, const double dx, const double dy)
virtual bool | performMovementMiddleMouseButton (const double eventTimeDelta, const double dx, const double dy)
virtual bool | performMovementRightMouseButton (const double eventTimeDelta, const double dx, const double dy)
virtual bool | performMouseDeltaMovement (const float dx, const float dy)
virtual void | applyAnimationStep (const double currentProgress, const double prevProgress)
virtual void | rotateTrackball (const float px0, const float py0, const float px1, const float py1, const float scale)
virtual void | rotateWithFixedVertical (const float dx, const float dy)
virtual void | rotateWithFixedVertical (const float dx, const float dy, const osg::Vec3f &up)
virtual void | panModel (const float dx, const float dy, const float dz=0.f)
virtual void | zoomModel (const float dy, bool pushForwardIfNeeded=true)
void | trackball (osg::Vec3d &axis, float &angle, float p1x, float p1y, float p2x, float p2y)
float | tb_project_to_sphere (float r, float x, float y)
virtual bool | startAnimationByMousePointerIntersection (const osgGA::GUIEventAdapter &ea, osgGA::GUIActionAdapter &us)
virtual void | allocAnimationData ()
Protected Member Functions inherited from osgGA::StandardManipulator
virtual bool | handleFrame (const osgGA::GUIEventAdapter &ea, osgGA::GUIActionAdapter &us)
virtual bool | handleResize (const osgGA::GUIEventAdapter &ea, osgGA::GUIActionAdapter &us)
virtual bool | handleMouseMove (const osgGA::GUIEventAdapter &ea, osgGA::GUIActionAdapter &us)
virtual bool | handleMouseDrag (const osgGA::GUIEventAdapter &ea, osgGA::GUIActionAdapter &us)
virtual bool | handleMousePush (const osgGA::GUIEventAdapter &ea, osgGA::GUIActionAdapter &us)
virtual bool | handleMouseRelease (const osgGA::GUIEventAdapter &ea, osgGA::GUIActionAdapter &us)
virtual bool | handleKeyDown (const osgGA::GUIEventAdapter &ea, osgGA::GUIActionAdapter &us)
virtual bool | handleKeyUp (const osgGA::GUIEventAdapter &ea, osgGA::GUIActionAdapter &us)
virtual bool | handleMouseDeltaMovement (const osgGA::GUIEventAdapter &ea, osgGA::GUIActionAdapter &us)
virtual bool | performMovement ()
virtual bool | performAnimationMovement (const osgGA::GUIEventAdapter &ea, osgGA::GUIActionAdapter &us)
void | addMouseEvent (const osgGA::GUIEventAdapter &ea)
void | flushMouseEventStack ()
virtual bool | isMouseMoving () const
float | getThrowScale (const double eventTimeDelta) const
virtual void | centerMousePointer (const osgGA::GUIEventAdapter &ea, osgGA::GUIActionAdapter &us)
void | fixVerticalAxis (osg::Vec3d &eye, osg::Quat &rotation, bool disallowFlipOver)
virtual bool | setCenterByMousePointerIntersection (const osgGA::GUIEventAdapter &ea, osgGA::GUIActionAdapter &us)
bool | getRelativeFlag (int index) const
void | setRelativeFlag (int index, bool value)
Protected Member Functions inherited from osgGA::CameraManipulator
| CameraManipulator ()
| CameraManipulator (const CameraManipulator &mm, const osg::CopyOp &copyOp=osg::CopyOp::SHALLOW_COPY)
virtual | ~CameraManipulator ()
std::string | getManipulatorName () const
Protected Member Functions inherited from osgGA::GUIEventHandler
virtual | ~GUIEventHandler ()
Protected Member Functions inherited from osg::NodeCallback
virtual | ~NodeCallback ()
Protected Member Functions inherited from osg::Callback
virtual | ~Callback ()
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

osg::Vec3d | _center
osg::Quat | _rotation
double | _distance
double | _trackballSize
double | _wheelZoomFactor
double | _minimumDistance
Protected Attributes inherited from osgGA::StandardManipulator
bool | _thrown
bool | _allowThrow
float | _mouseCenterX
float | _mouseCenterY
osg::ref_ptr< const osgGA::GUIEventAdapter > | _ga_t1
osg::ref_ptr< const osgGA::GUIEventAdapter > | _ga_t0
double | _delta_frame_time
double | _last_frame_time
osg::ref_ptr< osg::Node > | _node
double | _modelSize
bool | _verticalAxisFixed
osg::ref_ptr< AnimationData > | _animationData
int | _flags
int | _relativeFlags
Protected Attributes inherited from osgGA::CameraManipulator
unsigned int | _intersectTraversalMask
bool | _autoComputeHomePosition
osg::Vec3d | _homeEye
osg::Vec3d | _homeCenter
osg::Vec3d | _homeUp
osg::ref_ptr< CoordinateFrameCallback > | _coordinateFrameCallback
Protected Attributes inherited from osg::Callback
ref_ptr< Callback > | _nestedCallback
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Static Protected Attributes

static int | _minimumDistanceFlagIndex
Static Protected Attributes inherited from osgGA::StandardManipulator
static int | numRelativeFlagsAllocated

## Additional Inherited Members

Public Types inherited from osgGA::StandardManipulator
enum | UserInteractionFlags { UPDATE_MODEL_SIZE = 0x01 , COMPUTE_HOME_USING_BBOX = 0x02 , PROCESS_MOUSE_WHEEL = 0x04 , SET_CENTER_ON_WHEEL_FORWARD_MOVEMENT = 0x08 , DEFAULT_SETTINGS = UPDATE_MODEL_SIZE | PROCESS_MOUSE_WHEEL }
Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }
Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()
Static Protected Member Functions inherited from osgGA::StandardManipulator
static void | rotateYawPitch (osg::Quat &rotation, const double yaw, const double pitch, const osg::Vec3d &localUp=osg::Vec3d(0., 0., 0.))
static void | fixVerticalAxis (osg::Quat &rotation, const osg::Vec3d &localUp, bool disallowFlipOver)
static void | fixVerticalAxis (const osg::Vec3d &forward, const osg::Vec3d &up, osg::Vec3d &newUp, const osg::Vec3d &localUp, bool disallowFlipOver)
static int | allocateRelativeFlag ()

## Detailed Description

OrbitManipulator is base class for camera control based on focal center, distance from the center, and orientation of distance vector to the eye. This is the base class for trackball style manipulators.

## Constructor & Destructor Documentation

## OrbitManipulator() [1/2]

osgGA::OrbitManipulator::OrbitManipulator | ( | int | flags = DEFAULT_SETTINGS | ) |

References osgGA::StandardManipulator::DEFAULT_SETTINGS.

Referenced by META_Object(), and OrbitManipulator().

## OrbitManipulator() [2/2]

osgGA::OrbitManipulator::OrbitManipulator | ( | const OrbitManipulator & | om,
|  | const osg::CopyOp & | copyOp = osg::CopyOp::SHALLOW_COPY )

References OrbitManipulator(), and osg::CopyOp::SHALLOW_COPY.

## Member Function Documentation

## allocAnimationData()

virtual void osgGA::OrbitManipulator::allocAnimationData | ( |  | ) |

inline protected virtual

Reimplemented from osgGA::StandardManipulator.

References osgGA::StandardManipulator::_animationData.

## applyAnimationStep()

virtual void osgGA::OrbitManipulator::applyAnimationStep | ( | const double | currentProgress,
|  | const double | prevProgress )

protected virtual

Reimplemented from osgGA::StandardManipulator.

## getCenter()

const osg::Vec3d & osgGA::OrbitManipulator::getCenter | ( |  | ) | const

## getDistance()

double osgGA::OrbitManipulator::getDistance | ( |  | ) | const

## getElevation()

double osgGA::OrbitManipulator::getElevation | ( |  | ) | const

## getFusionDistanceMode()

virtual osgUtil::SceneView::FusionDistanceMode osgGA::OrbitManipulator::getFusionDistanceMode | ( |  | ) | const

virtual

Get the FusionDistanceMode. Used by SceneView for setting up stereo convergence.

Reimplemented from osgGA::CameraManipulator.

## getFusionDistanceValue()

virtual float osgGA::OrbitManipulator::getFusionDistanceValue | ( |  | ) | const

virtual

Get the FusionDistanceValue. Used by SceneView for setting up stereo convergence.

Reimplemented from osgGA::CameraManipulator.

## getHeading()

double osgGA::OrbitManipulator::getHeading | ( |  | ) | const

## getInverseMatrix()

virtual osg::Matrixd osgGA::OrbitManipulator::getInverseMatrix | ( |  | ) | const

virtual

get the position of the manipulator as a inverse matrix of the manipulator, typically used as a model view matrix.

Implements osgGA::CameraManipulator.

Reimplemented in osgGA::NodeTrackerManipulator.

## getMatrix()

virtual osg::Matrixd osgGA::OrbitManipulator::getMatrix | ( |  | ) | const

virtual

get the position of the manipulator as 4x4 Matrix.

Implements osgGA::CameraManipulator.

Reimplemented in osgGA::NodeTrackerManipulator.

## getMinimumDistance()

double osgGA::OrbitManipulator::getMinimumDistance | ( | bool * | relativeToModelSize = NULL | ) | const

References NULL.

## getRotation()

const osg::Quat & osgGA::OrbitManipulator::getRotation | ( |  | ) | const

## getTrackballSize()

double osgGA::OrbitManipulator::getTrackballSize | ( |  | ) | const

inline

Get the size of the trackball relative to the model size.

References _trackballSize.

Referenced by setTrackballSize().

## getTransformation() [1/2]

virtual void osgGA::OrbitManipulator::getTransformation | ( | osg::Vec3d & | eye,
|  | osg::Quat & | rotation ) const

virtual

Gets manipulator's eye position and eye orientation.

Implements osgGA::StandardManipulator.

## getTransformation() [2/2]

virtual void osgGA::OrbitManipulator::getTransformation | ( | osg::Vec3d & | eye,
|  | osg::Vec3d & | center,
|  | osg::Vec3d & | up ) const

virtual

Gets manipulator's focal center, eye position, and up vector.

Implements osgGA::StandardManipulator.

## getWheelZoomFactor()

double osgGA::OrbitManipulator::getWheelZoomFactor | ( |  | ) | const

inline

Get the mouse wheel zoom factor.

References _wheelZoomFactor.

Referenced by setWheelZoomFactor().

## handleMouseWheel()

virtual bool osgGA::OrbitManipulator::handleMouseWheel | ( | const osgGA::GUIEventAdapter & | ea,
|  | osgGA::GUIActionAdapter & | us )

protected virtual

Reimplemented from osgGA::StandardManipulator.

## META_Object()

osgGA::OrbitManipulator::META_Object | ( | osgGA | ,
|  | OrbitManipulator | )

References OrbitManipulator().

## panModel()

virtual void osgGA::OrbitManipulator::panModel | ( | const float | dx,
|  | const float | dy,
|  | const float | dz = 0.f )

protected virtual

## performMouseDeltaMovement()

virtual bool osgGA::OrbitManipulator::performMouseDeltaMovement | ( | const float | dx,
|  | const float | dy )

protected virtual

Reimplemented from osgGA::StandardManipulator.

## performMovementLeftMouseButton()

virtual bool osgGA::OrbitManipulator::performMovementLeftMouseButton | ( | const double | eventTimeDelta,
|  | const double | dx,
|  | const double | dy )

protected virtual

Reimplemented from osgGA::StandardManipulator.

Reimplemented in osgGA::NodeTrackerManipulator.

## performMovementMiddleMouseButton()

virtual bool osgGA::OrbitManipulator::performMovementMiddleMouseButton | ( | const double | eventTimeDelta,
|  | const double | dx,
|  | const double | dy )

protected virtual

Reimplemented from osgGA::StandardManipulator.

Reimplemented in osgGA::NodeTrackerManipulator, and osgGA::TerrainManipulator.

## performMovementRightMouseButton()

virtual bool osgGA::OrbitManipulator::performMovementRightMouseButton | ( | const double | eventTimeDelta,
|  | const double | dx,
|  | const double | dy )

protected virtual

Reimplemented from osgGA::StandardManipulator.

Reimplemented in osgGA::NodeTrackerManipulator, and osgGA::TerrainManipulator.

## rotateTrackball()

virtual void osgGA::OrbitManipulator::rotateTrackball | ( | const float | px0,
|  | const float | py0,
|  | const float | px1,
|  | const float | py1,
|  | const float | scale )

protected virtual

## rotateWithFixedVertical() [1/2]

virtual void osgGA::OrbitManipulator::rotateWithFixedVertical | ( | const float | dx,
|  | const float | dy )

protected virtual

## rotateWithFixedVertical() [2/2]

virtual void osgGA::OrbitManipulator::rotateWithFixedVertical | ( | const float | dx,
|  | const float | dy,
|  | const osg::Vec3f & | up )

protected virtual

## setByInverseMatrix()

virtual void osgGA::OrbitManipulator::setByInverseMatrix | ( | const osg::Matrixd & | matrix | ) |

virtual

set the position of the matrix manipulator using a 4x4 Matrix.

Implements osgGA::CameraManipulator.

## setByMatrix()

virtual void osgGA::OrbitManipulator::setByMatrix | ( | const osg::Matrixd & | matrix | ) |

virtual

set the position of the matrix manipulator using a 4x4 Matrix.

Implements osgGA::CameraManipulator.

Reimplemented in osgGA::NodeTrackerManipulator, and osgGA::TerrainManipulator.

## setCenter()

virtual void osgGA::OrbitManipulator::setCenter | ( | const osg::Vec3d & | center | ) |

virtual

## setDistance()

virtual void osgGA::OrbitManipulator::setDistance | ( | double | distance | ) |

virtual

## setElevation()

void osgGA::OrbitManipulator::setElevation | ( | double | elevation | ) |

## setHeading()

void osgGA::OrbitManipulator::setHeading | ( | double | azimuth | ) |

## setMinimumDistance()

virtual void osgGA::OrbitManipulator::setMinimumDistance | ( | const double & | minimumDistance,
|  | bool | relativeToModelSize = false )

virtual

## setRotation()

virtual void osgGA::OrbitManipulator::setRotation | ( | const osg::Quat & | rotation | ) |

virtual

## setTrackballSize()

virtual void osgGA::OrbitManipulator::setTrackballSize | ( | const double & | size | ) |

virtual

References getTrackballSize().

## setTransformation() [1/2]

virtual void osgGA::OrbitManipulator::setTransformation | ( | const osg::Vec3d & | eye,
|  | const osg::Quat & | rotation )

virtual

Sets manipulator by eye position and eye orientation.

Implements osgGA::StandardManipulator.

## setTransformation() [2/2]

virtual void osgGA::OrbitManipulator::setTransformation | ( | const osg::Vec3d & | eye,
|  | const osg::Vec3d & | center,
|  | const osg::Vec3d & | up )

virtual

Sets manipulator by eye position, center of rotation, and up vector.

Implements osgGA::StandardManipulator.

Reimplemented in osgGA::TerrainManipulator.

## setWheelZoomFactor()

virtual void osgGA::OrbitManipulator::setWheelZoomFactor | ( | double | wheelZoomFactor | ) |

virtual

References getWheelZoomFactor().

## startAnimationByMousePointerIntersection()

virtual bool osgGA::OrbitManipulator::startAnimationByMousePointerIntersection | ( | const osgGA::GUIEventAdapter & | ea,
|  | osgGA::GUIActionAdapter & | us )

protected virtual

Reimplemented from osgGA::StandardManipulator.

## tb_project_to_sphere()

float osgGA::OrbitManipulator::tb_project_to_sphere | ( | float | r,
|  | float | x,
|  | float | y )

protected

## trackball()

void osgGA::OrbitManipulator::trackball | ( | osg::Vec3d & | axis,
|  | float & | angle,
|  | float | p1x,
|  | float | p1y,
|  | float | p2x,
|  | float | p2y )

protected

## zoomModel()

virtual void osgGA::OrbitManipulator::zoomModel | ( | const float | dy,
|  | bool | pushForwardIfNeeded = true )

protected virtual

## Member Data Documentation

## _center

osg::Vec3d osgGA::OrbitManipulator::_center

protected

## _distance

double osgGA::OrbitManipulator::_distance

protected

## _minimumDistance

double osgGA::OrbitManipulator::_minimumDistance

protected

## _minimumDistanceFlagIndex

int osgGA::OrbitManipulator::_minimumDistanceFlagIndex

static protected

## _rotation

osg::Quat osgGA::OrbitManipulator::_rotation

protected

## _trackballSize

double osgGA::OrbitManipulator::_trackballSize

protected

Referenced by getTrackballSize().

## _wheelZoomFactor

double osgGA::OrbitManipulator::_wheelZoomFactor

protected

Referenced by getWheelZoomFactor().

The documentation for this class was generated from the following file:

- OrbitManipulator